class Sprites{
	constructor(src,width,height,canvas){
		this.img=document.createElement('img');
		this.img.src=src;
		this.width=width;
		this.height=height;		
		this.can=canvas;
		this.fra=0;
		this.soundsA=new Array();
	}
	setSound(sound){
		for(var i=0;i<arguments.length;i++){
			if(i>0){
				if(this.soundsA[arguments[i]]==undefined){
					this.soundsA[arguments[i]]=new Array()
					this.soundsA[arguments[i]].push(sound);
				}else{
					this.soundsA[arguments[i]].push(sound);
				}
			}
		}
		
	}
	bg(x,y,col){
		if(col==undefined){			
			this.can.drawImage(this.img,x,y);
		}else{			
			this.can.drawImage(this.img,col*this.width,0,this.width,this.height,x,y,this.width,this.height);
		}
	}
	chara(x,y){
		this.can.drawImage(this.img,x-(this.width/2),y-this.height);
	}	
	action(x,y,f){	
		if(this.fra*this.width>=this.img.width){
			if(f==undefined){
				this.fra=0;
			}else{
				this.fra=f;
			}
		}
		if(this.soundsA[this.fra]!=undefined){
			for(var i=0;i<this.soundsA[this.fra].length;i++){
				this.soundsA[this.fra][i].play();
			}
		}
		this.can.drawImage(this.img,this.fra*this.width,0,this.width,this.height,x-(this.width/2),y-this.height,this.width,this.height);		
		this.fra++;		
	}
	stop(x,y){				
		this.can.drawImage(this.img,this.fra*this.width,0,this.width,this.height,x-(this.width/2),y-this.height,this.width,this.height);
		var ram=Math.floor(Math.random()*10);		
		if(ram<5){
			this.fra=0;
		}else if(ram==6){
			this.fra=1;
		}else{
			this.fra=2;
		}
	}
	
}
class Areacheck{
	constructor(x,y,x1,y1){
		this.x=x;
		this.x1=x1;
		this.y=y;
		this.y1=y1;
	}
	c(x,y){
		if(x>=this.x&x<=this.x1&y>=this.y&y<=this.y1){
			return true
		}else {
			return false
		}
		
	}	
}

var totalv=window.innerHeight;
var totalh=window.innerWidth;
var lang='';
var drawIn;
var m={x:0,y:0};

var yop={x:1700,y:650,xt:1700,yt:650,act:'hug',hp:100,count:0,sta:3};
var girl={x:1700,y:650,xt:1700,yt:640,act:'hug'};
var stage='';
var day=1;
var storyv='talk';
var mis={x:100,y:650,xt:100,yt:650,act:'stop',hp:100,count:0,meet:false,dia:false,win:false};
var fx={x:0,y:0};
var freeze={st:false,count:0,opa:0,stage:'',go:0};
var sleepv=0;
var bgmv={c1:50,c2:0,c3:0,c4:10};
var canvas=document.createElement('canvas');
canvas.style.zIndex=1;
canvas.style.userSelect='none';
canvas.style.position='absolute';
canvas.style.top=(totalv-resize(700))/2;
canvas.style.left=(totalh-resize(1200))/2;
canvas.height=resize(700);
canvas.width=resize(1200);
canvas.style.borderRadius='10px';
var incanvas=canvas.getContext('2d');
document.body.appendChild(canvas);
incanvas.scale(resize(1),resize(1));
incanvas.fillStyle='#734d26';
incanvas.fillRect(0,0,1300,800);
incanvas.fillStyle='#000000';
incanvas.font='150px arial';
incanvas.fillText('loading',350,350);

var vidA=new Array();
vidA[0]='hiddenroom/win1.mp4';
vidA[1]='hiddenroom/gameover.mp4';
var vidN=0;
var vide=document.createElement('video');
vide.style.zIndex=10;
vide.loop=true;
vide.preLoad=true;
vide.style.position='absolute';
vide.style.left=(totalh-resize(1190))/2;
vide.style.top=(totalv-resize(680))/2;
vide.style.userSelect='none';
vide.height=resize(680);
vide.width=resize(680);
document.body.appendChild(vide);
vide.style.borderRadius='20px';
vide.style.display='none';
vide.src='hiddenroom/win1.mp4';
//sounds
var seclick=new Audio();
seclick.src='hiddenroom/click.wav';
var sewalk=new Audio();
sewalk.src='hiddenroom/shoes.wav';
var sewalk2=new Audio();
sewalk2.src='hiddenroom/shoes.wav';
var sekick=new Audio();
sekick.src='hiddenroom/wush.wav';
var sedas=new Audio();
sedas.src='hiddenroom/wush.wav';
var sehit=new Audio();
sehit.src='hiddenroom/hit.wav';
var sehity=new Audio();
sehity.src='hiddenroom/hit.wav';
var seknee=new Audio();
seknee.src='hiddenroom/kneethud.wav';
var semia=new Audio();
semia.src='hiddenroom/misaa.wav';
var semida=new Audio();
semida.src='hiddenroom/misada.wav';

var semama1=new Audio();
semama1.src='hiddenroom/mama1.wav';
var semama2=new Audio();
semama2.src='hiddenroom/mama2.wav';

var sefck=new Audio();
sefck.src='hiddenroom/fck.wav';

var sewalkp=new Audio();
sewalkp.src='hiddenroom/walkingpeople.wav';
sewalkp.volume=0.6;
var setrain=new Audio();
setrain.src='hiddenroom/train.wav';
setrain.volume=0.6;
var secri=new Audio();
secri.volume=0.6;
secri.src='hiddenroom/cricket.wav';
var secars=new Audio();
secars.src='hiddenroom/cars.wav';
secars.volume=0.6;
var seice=new Audio();
seice.src='hiddenroom/iceglass.wav';
seice.volume=0.2;
var sedrink=new Audio();
sedrink.src='hiddenroom/drinkice.wav';
sedrink.volume=0.3;

var ljp=new Areacheck(145,85,450,615);
var len=new Areacheck(710,85,1025,615);
var bfight=new Areacheck(910,478,1186,570);
var bstory=new Areacheck(910,488,1186,620);
var bwatch=new Areacheck(910,640,1186,686);
var bnext=new Areacheck(900,100,1040,240);
var bback=new Areacheck(900,500,1040,740);
var bmenub=new Areacheck(1090,390,1170,460);

//sprites
var bglang=new Sprites('hiddenroom/bg_lang.png',1200,700,incanvas);
var bgsleep=new Sprites('hiddenroom/bg_sleep.png',1200,700,incanvas);
var bgsleepono=new Sprites('hiddenroom/bg_sleep-ono.png',280,173,incanvas);
var bgmenu=new Sprites('hiddenroom/bg_menu.png',1200,700,incanvas);
var bgmenubut=new Sprites('hiddenroom/bg_menubuttons.png',280,210,incanvas);
var bgover=new Sprites('hiddenroom/bg_gameover.png',1200,700,incanvas);

var watchbu=new Sprites('hiddenroom/watchbutton.png',140,140,incanvas);

var bgbar=new Sprites('hiddenroom/bg_bar.png',1200,700,incanvas);
var bgbarmisa=new Sprites('hiddenroom/bg_barmisa.png',400,600,incanvas);

var bgbmenu=new Sprites('hiddenroom/bg_bmenu.png',80,70,incanvas);
//fight sprites
var bgfight=new Sprites('hiddenroom/bg_fight.png',1200,700,incanvas);

var mi=new Sprites('hiddenroom/misa.png',140,400,incanvas);
var miw=new Sprites('hiddenroom/misaw.png',180,400,incanvas);
miw.setSound(sewalk,2,3);
var mia=new Sprites('hiddenroom/misaa.png',400,400,incanvas);
mia.setSound(sekick,1);
mia.setSound(semia,1);
var mida=new Sprites('hiddenroom/misada.png',250,400,incanvas);
mida.setSound(semida,1);
mida.setSound(sewalk,1);
mida.setSound(seknee,2);
var mido=new Sprites('hiddenroom/misado.png',240,400,incanvas);
mido.setSound(sekick,2);
var mid=new Sprites('hiddenroom/misad.png',380,180,incanvas);
mid.setSound(sekick,2);
var miwi=new Sprites('hiddenroom/misawi.png',180,400,incanvas);

var yopa1g=new Sprites('hiddenroom/yopa1g.png',180,400,incanvas);
var yopa1=new Sprites('hiddenroom/yopa1.png',160,400,incanvas);
var yopa1w=new Sprites('hiddenroom/yopa1w.png',200,400,incanvas);
yopa1w.setSound(sewalk2,2,3);
var yopa1a=new Sprites('hiddenroom/yopa1a.png',400,400,incanvas);
yopa1a.setSound(sedas,2);
var yopa1da=new Sprites('hiddenroom/yopa1da.png',360,400,incanvas);
var yopa1d=new Sprites('hiddenroom/yopa1d.png',480,310,incanvas);
yopa1d.setSound(seknee,2);
var yopa1wi=new Sprites('hiddenroom/yopa1wi.png',260,470,incanvas);
var yopa1pa=new Sprites('hiddenroom/yopa1pa.png',160,400,incanvas);

var girl1=new Sprites('hiddenroom/girl1.png',220,400,incanvas);
girl1.setSound(sewalk,1,3);

yop.g=yopa1g;
yop.base=yopa1;
yop.w=yopa1w;
yop.a=yopa1a;
yop.da=yopa1da;
yop.d=yopa1d;
yop.wi=yopa1wi;
yop.pa=yopa1pa;
//dialogs
var di=new Array();
di[1]=1;
di[2]=1;

di['jpfight']='ファイトモード：　セリフ+ファイト+動画＝全部';
di['enfight']="Fight mode: dialogs + fight + videos= everything";
di['jpstory']='ストーリーモード：　セリフ　+　動画、ファイト無し';
di['enstory']="Story mode: dialogs and videos, no figthing";
di['jpwatch']='動画モード：　動画だけ';
di['enwatch']="Video mode: only the videos.";

di['jpnext']='次の動画を再生。';
di['ennext']="Play next video.";
di['jpback']='メニュー画面にもどる。';
di['enback']="Back to the menu.";

di['jpcredits1']='声：';
di['jpcredits2']='みさ：『音声素材：戦え女の子』ＣＶ：七凪るとろ】';
di['jpcredits3']='母：【音声素材】 戦え女の子 【CV:浅倉ともよバージョン】';
di['jpcredits4']='下町妄想街 2023年';

di['encredits1']="Voices:";
di['encredits2']="Misa: Voice library: Tatakae onna noko CV: Nanagi Rutoro"
di['encredits3']="Mother: Voice library: Tatakae onna noko CV: Asakura Tomoyo";
di['encredits4']='Shitamachi mousou-gai 2023';

di['jpcont']='コンティニュー？';
di['jpcontx']='（クリックしてコンティニュー）';
di['encont']="Continue?";
di['encontx']="(click to continue)";

di['jpattaex']='ここにクリックし攻撃をする';
di['jpdodgeex']='ここにクリックし攻撃をかわす';
di['enattaex']="Click here to attack";
di['endodgeex']="Click here to dodge";
//---------------day1
di['jp1tk1']='みさ：いらっしゃいませ！お客様今日は何にしますか？いつもの？了解しました。。。';
di['jp1tk2']='みさ：バーテンダーを初めてもうしばらくたつが、未だにお客さんとの会話ができなくて、こんな見た目だからクールに見えて相手からは話題がふりづらいらしい';
di['jp1tk3']='みさ：私はただの人見知り。。。本当は緊張してて無言になりがち、ファッションはパパとママの影響かな？ママはロックバンドのボーカルだったからこういうのけっこう着ててかっこいいなぁって';
di['jp1tk4']='みさ：パパはごりごりのマッチョで、ジンズとかバンドのTシャツを毎日着てる、シンプルだけどなんかかっこいい';
di['jp1tk5']='みさ：二人ともかっこうよくてコミュニケーション能力も高くて、憧れるな。。。たぶんその理由でいまだに実家ぐらし、パパとママ仲良くて、夜になると。。。';
di['jp1tk6']='みさ：隣の部屋からベッドのギシギシ音が止まらなくて。。。私もあんなのしたい、されたい。。。でも奥手で出会いが中々ね。。。';
di['jp1tk7']='みさ：たまに痴漢される妄想する、夜中まで仕事してるからお帰りで酔っ払いのおじさんにされないかなって。。。私おじさん好き。。。ちょっとお腹でてるの可愛いぃ！';
di['jp1tk8']='みさ：もう帰る時間だ、今日は犯されるかな。。。';

di['en1tk1']="Misa: Welcome ,sir! What you wanna have today? The usual? Ok, as you want...";
di['en1tk2']="Misa: Even after all this time working as a bartender I'm still not able to engage a conversation with my customers, and it seems my appearance makes them a little afraid to talk to me too..";
di['en1tk3']="Misa: I'm just a shy girl...I get so anxious I don't know what to say and in the end I say nothing, my clothes? I got that from my parents, mom was a singer at a rock band and she used to wear this kind of clothes, girl she was cool!";
di['en1tk4']="Misa: Dad is a buff guy, he use to wear jeans and some band T-shirt, very simple but it's kind of cool";
di['en1tk5']="Misa: They're both so cool and communicative, I wish I was like them...probably that's why I still live with them, they've such a good chemistry, and at night they...";
di['en1tk6']="Misa: I can hear the sound of their bed, all night...I wish I could do that too, but I'm too shy...";
di['en1tk7']="Misa: Sometimes I fantasize about been attacked, you know I work till late of night so there's a good chance for a drunken older man to attack me...yeah, older guys are my thing...that bulging belly it's so cute!";
di['en1tk8']="Misa: And it's time to go home, will a cute older man attack me tonight?";

//before fight
di['jp1bf1']='すずちゃん：きゃぁ痴漢だ！みさちゃん助けて！';
di['jp1bf2']='みさ：（なんで私じゃない？！ぇぇええ私を痴漢してよ！しかも私が大好きなおじさんじゃないか！）';
di['jp1bf3']='みさ：お。。。お前、すずちゃんから手を離して。。。';
di['jp1bf4']='おじさん：するかよ、こいつといっぱいエッチするよ！ぐははは！';
di['jp1bf5']='みさ：しょうがないやるか。。。';
di['jp1bf6']='みさ：（違う意味でやりたかった！）';
di['jp1bf7']='おじさんを攻撃してすずちゃんを解放して';

di['en1bf1']="Suzu-chan: A pervert! Misa-chan help me!";
di['en1bf2']="Misa: (Why not me?! Come on attack me please! And look, he's just my type!)";
di['en1bf3']="Misa: Hey you...take your hands off Suzu-chan...";
di['en1bf4']="Older man: Not a chance! I'll fuck this cuty in every way you can imagine! Ha ha ha ha!";
di['en1bf5']="Misa: Oh gosh...you asked for this...";
di['en1bf6']="Misa: (Gosh, I wish I was hitting this guy in a sexual way!!)";
di['en1bf7']="Hit the older man to release Suzu-chan";

di['jp1af1']='すずちゃん：　ありがとうみさちゃん！';

di['en1af1']="Suzu-chan: Thank you Misa-chan!";
//win----------------------------
di['jp1wi1']='みさ：ぜんぜん意識がないよな。。。周りに誰もいないし。。。このおじさんけっこうタイプだ。。。見るだけならいいかな。。。';
di['jp1wi2']='みさ：すっごい立ってる、めっちゃいいちんぽ。。。こんな近くで見ると興奮しちゃうよな。。。';
di['jp1wi3']='みさ：いやや、こんなのバレたらすっごい恥ずかしいから！特にパパとママに知られたらすっごいハズイよ！早く帰ろう！';

di['en1wi1']="Misa: He looks unconscious...and there's nobody around too...girl his just my type...Ok I'm just looking, nothing more than looking...";
di['en1wi2']="Misa: He's soo hard, look at that volume under his pants...looking it so closely makes me so excited....";
di['en1wi3']="Misa: Oh gosh, if mom and dad knows about it I'll be sooo embarrassed, have to go right now!";
//sleep time
di['jp1sl1']='みさ：危なかった。。。あの可愛いおじさんを犯すところだった。。。私たまってるな、オナニーしようかな。。。';
di['jp1sl2']='みさ：パパとママまたやってるな。。。娘がこんなにたまってるのに。。。';
di['jp1sl3']='みさ：ママすっごい気持ちよさそう。。。まあねぇ、パパのちんこデカくて太いし。。。どうやって分かる？いや、パパがたまに一人でやってるの見てて。。。';
di['jp1sl4']='みさ：だってあんなかたくて大きいのいたら見ちゃうでしょう？パパがシコシコしてるのみたら私まで興奮して濡れちゃったり。。。';
di['jp1sl5']='みさ：ああもう！エッチがしたい！！';
di['jp1sl6']='体験版はここまで';

di['en1sl1']="Misa: Gosh, I was about to attack that cute older man, geez I'm so horny right now! I have to release this...";
di['en1sl2']="Misa: Hell, mom and dad is doing it again...even though their daughter has no sex at all...";
di['en1sl3']="Misa: Mom seems always having so much pleasure...I imagine how it is, dad has such a thick and long cock...how I know that? You know I sometimes get dad fapping by himself...";
di['en1sl4']="Misa: Oh, he don't know that, but looking that huge hard thing makes me so excited I usually get wet...";
di['en1sl5']="Misa: Geez I need some real sex like right now!";
di['en1sl6']="The Trial version ends here.";


//functions
function resize(size){		
	if(Math.floor((totalh/totalv)*1000)/1000>=1.714){
		var s=Math.floor(((size*totalv)/720)*1000)/1000;
	}else{
		var s=Math.floor(((size*totalh)/1220)*1000)/1000;
	}
	return s;	
}
function pl(sound){
	sound.currentTime=0;
	sound.play();	
}
function bgmf(basho){		
	if(basho=='home'){
		bgmv.c1++;
		bgmv.c2++;
		bgmv.c3++;				
		bgmv.c4++;
		if(bgmv.c1>=15){
			if(Math.floor(Math.random()*2)==1){
				pl(semama2);			
			}else{
				pl(semama1);			
			}
			bgmv.c1=0;
		}
		if(bgmv.c2>=30){
			if(Math.floor(Math.random()*2)==1){
				pl(secri);			
			}
			bgmv.c2=0;
		}
		if(bgmv.c3>=60){
			if(Math.floor(Math.random()*2)==1){
				pl(secars);
			}
			bgmv.c3=0;
		}
		if(bgmv.c4>=4){
			if(Math.floor(Math.random()*2)==1){
				pl(sefck);			
			}
			bgmv.c4=0;
		}
	}else if(basho=='bar'){
		bgmv.c1++;
		bgmv.c2++;		
		bgmv.c4++;
		if(bgmv.c1>=80){
			pl(sewalkp);
			bgmv.c1=0;
		}
		if(bgmv.c2>=70){
			if(Math.floor(Math.random()*2)==1){
				pl(sedrink);			
			}
			bgmv.c2=0;
		}		
		if(bgmv.c4>=90){
			if(Math.floor(Math.random()*2)==1){
				pl(seice);
			}
			bgmv.c4=0;
		}
	}else{
		bgmv.c1++;
		bgmv.c2++;
		bgmv.c3++;		
		bgmv.c4++;
		if(bgmv.c1>=55){
			pl(sewalkp);
			bgmv.c1=0;
		}
		if(bgmv.c2>=30){
			if(Math.floor(Math.random()*2)==1){
				pl(secri);			
			}
			bgmv.c2=0;
		}
		if(bgmv.c3>=100){
			pl(setrain);
			bgmv.c3=0;
		}
		if(bgmv.c4>=30){
			if(Math.floor(Math.random()*2)==1){
				pl(secars);
			}
			bgmv.c4=0;
		}
	}
}
function roundRect(x,y,width,height,r){		
	incanvas.beginPath();
	incanvas.moveTo(x+r,y);
	incanvas.lineTo(x+(width-r),y);
	incanvas.arcTo(x+width,y,x+width,y+r,r);
	incanvas.lineTo(x+width,y+(height-r));
	incanvas.arcTo(x+width,y+height,x-r,y+height+r,r);
	incanvas.lineTo(x+r,y+height);
	incanvas.arcTo(x,y+height,x,(y+height)-r,r);
	incanvas.lineTo(x,y+r);
	incanvas.arcTo(x,y,x+r,y,r);
	incanvas.closePath();
	incanvas.fill();
}
//dialogs function
function diF(type,tx,x,y,size,width,height,color){
	if(type=='line'){
		incanvas.save();
		incanvas.fillStyle='#ffffff';
		incanvas.globalAlpha=0.6;
		roundRect(x-20,y-20,width+(size*2),height+(size*2),20);	
		incanvas.restore();
	}
	
	di[2]++;
	if(di[2]>10){
		di[2]=0;
	}
	
	if(color==undefined){
		incanvas.fillStyle='#000000';	
	}else{
		incanvas.fillStyle=color;	
	}
	if(size==undefined){
		incanvas.font='10px arial';
	}else{
		incanvas.font=size+'px arial';
	}	
	if(width!=undefined&type=='line'){		
		var txt=di[tx+di[1]];
		var line=0;
		var ttxt='';		
		for(var i=0;i<txt.length;i++){
			ttxt+=txt.charAt(i);			
			if(i+1>=txt.length){
				line++;
				if(di[2]>5){
					if(di[tx+(di[1]+1)]!=undefined){
						ttxt+='>';
					}else{
						ttxt+='.';
					}
				}
				incanvas.fillText(ttxt,x,y+(size*line));
				ttxt='';
			}else if(incanvas.measureText(ttxt).width>=width){				
				line++;				
				incanvas.fillText(ttxt,x,y+(size*line));
				ttxt='';
			} 
		}	
	}else{
		incanvas.fillText(tx,x,y);
	}	
}
function yop1(){
	if(yop.act!='win'){
		yop.count++;
		if(yop.count>=20){
			yop.count=0;
			if(yop.sta<2){
				yop.sta++;
			}
		}
	}
	if(yop.act=='stop'){			
		if(Math.abs((yop.xt+fx.x)-mis.xt)>200){
			yop.act='walk';
		}else {						
			if(yop.sta>0){
				yop.act='attack';			
				yop.a.fra=0;				
			}else{
				yop.act='preattack';			
				yop.pa.fra=0;
			}
		}
	}else if(yop.act=='walk'){		
		if(Math.abs((yop.xt+fx.x)-mis.xt)>180){
			if((yop.xt+fx.x)>mis.xt){
				yop.xt-=20;			
			}else{
				yop.xt+=20;			
			}
		}else{			
			if(yop.sta>0){
				yop.act='attack';			
				yop.a.fra=0;				
			}else{
				yop.act='preattack';			
				yop.pa.fra=0;
			}						
		}
	}else if(yop.act=='preattack'){		
		if(yop.pa.fra*yop.pa.width>=yop.pa.img.width){						
			if(yop.sta>0){
				yop.act='attack';			
				yop.a.fra=0;				
			}else{
				yop.act='preattack';			
				yop.pa.fra=0;
			}
		}		
	}else if(yop.act=='attack'){		
		if(yop.a.fra*yop.a.width>=yop.a.img.width){			
			yop.sta--;
			if(Math.floor(Math.random()*2)==1){
				yop.act='stop';
				yop.base.fra=0;
			}else{
				if(yop.sta>0){
					yop.act='attack';			
					yop.a.fra=0;
				}else{
					yop.act='preattack';			
					yop.pa.fra=0;
				}
			}
		}
		if(Math.abs((yop.xt+fx.x)-mis.xt)<=200){				
			if(mis.act!='damage'&mis.act!='dodge'&yop.a.fra>1&yop.a.fra<4){
				if(mis.hp>0){
					mis.hp-=10;			
				}
				if(mis.hp<0){
					mis.hp=0;
				}
				pl(sehity);	
				if(mis.xt>150){
					mis.xt-=150;				
				}
				mis.act='damage';				
				mida.fra=0;				
			}			
		}
	}else if(yop.act=='win'){		
		yop.count++;
		if(yop.count>=30){
			freeze.st=true;
			freeze.stage='over';
			vide.src='hiddenroom/gameover.mp4';
		}
	}else if(yop.act=='damage'){		
		if(yop.hp<=0){
			if((yop.da.fra+2)*yop.da.width>=yop.da.img.width){								
				yop.d.fra=0;
				yop.act='down';				
				mis.win=true;
			}
		}else if((yop.da.fra)*yop.da.width>=yop.da.img.width){								
			if(Math.abs((yop.xt+fx.x)-mis.xt)>180){
				yop.act='stop';			
				yop.a.fra=0;
			}else{
				if(yop.sta>0){
					yop.act='attack';			
					yop.a.fra=0;
				}else{
					yop.act='preattack';			
					yop.pa.fra=0;
				}								
			}
		}
	}
}

function yopdraw(){
	if(yop.act=='stop'){
		yop.base.action(yop.xt+fx.x,yop.yt);
	}else if(yop.act=='walk'){
		yop.w.action(yop.xt+fx.x,yop.yt);	
	}else if(yop.act=='preattack'){
		yop.pa.action(yop.xt+fx.x,yop.yt);
	}else if(yop.act=='attack'){
		yop.a.action(yop.xt+fx.x,yop.yt);
	}else if(yop.act=='win'){
		yop.wi.action(yop.xt+fx.x,yop.yt);
	}else if(yop.act=='damage'){
		yop.da.action(yop.xt+fx.x,yop.yt);				
	}else if(yop.act=='down'){				
		yop.d.action(yop.xt+fx.x,yop.yt,4);
	}else if(yop.act=='hug'){
		yop.g.action(yop.xt+fx.x,yop.yt);		
	}
}
function misaf(){
	if(mis.act=='stop'){		
		if(mis.win==false){			
			if(Math.abs(mis.xt-m.x)>50&mis.dia==false){
				mis.act='walk';
			}
		}else{
			mis.act='win';
		}
	}else if(mis.act=='walk'&mis.dia==false){			
			if(mis.xt<m.x){
				if(mis.xt<1100&mis.xt<yop.xt){
					if(mis.xt<600){
						if(mis.xt<(yop.xt+fx.x)-50){
							mis.xt+=30;							
						}
						if(mis.xt>600){
							fx.x-=30;							
							mis.xt=600;							
						}
					}else {
						if(fx.x>-700){
							fx.x-=30;		
							if(fx.x<-700){									
								fx.x=-700;
							}
						}else{					
							if(mis.xt<(yop.xt+fx.x)-50){
								mis.xt+=30;															
							}
						}							
					}
				}					
			}else if(mis.xt>50){
				if(mis.xt>600){
					mis.xt-=30;
					if(mis.xt<50){
						mis.xt=50;
					}
				}else{
					if(fx.x<0){
						fx.x+=30;													
						if(fx.x>0){
							fx.x=0;
							mis.xt-=30;
						}
					}else if(mis.xt>50){
						mis.xt-=30;
						if(mis.xt<50){
							mis.xt=50;
						}
					}
				}					
			}
			if(Math.abs(mis.xt-m.x)<=50){
				mis.act='stop';
			}						
	}else if(mis.act=='attack'){		
		if(Math.abs((yop.xt+fx.x)-mis.xt)<200&mia.fra>1&mia.fra<4){	
			if((yop.xt+fx.x)>50&(yop.xt+fx.x)<1100){
				if(mia.fra==2){
					if((yop.xt+150+fx.x)>50&(yop.xt+150+fx.x)<1100){
						yop.xt+=150;
					}
				}else if(mia.fra==3){
					if((yop.xt+60+fx.x)>50&(yop.xt+6+fx.x)<1100){
						yop.xt+=60;
					}
				}	
			}				
			if(yop.act!='damage'){
				pl(sehit);
				if(yop.hp>0){
					if(day<3){
						yop.hp-=10;
					}else{
						yop.hp-=7;
					}
				}
				if(yop.hp<=0){					
					yop.hp=0;
				}											
			}
			if(yop.act=='hug'){
				yop.act='stop';
				yop.a.fra=0;
				girl.act='free';					
			}else{
				yop.act='damage';
				yop.da.fra=0;					
			}
		}					
		if((mia.fra)*mia.width>=mia.img.width){				
			mis.act='stop';				
		}
	}else if(mis.act=='dodge'){		
		if((mido.fra)*mido.width>=mido.img.width){
			mis.act='stop';				
		}
	}else if(mis.act=='damage'){		
		if(mis.hp<=0){					
			if((mida.fra+4)*mida.width>=mida.img.width){
				mis.act='down';			
				yop.act='win';						
				yop.count=0;
				yop.wi.fra=0;				
			}
		}else{
			if((mida.fra+1)*mida.width>=mida.img.width){								
				mis.act='stop';									
			}
		}
	}else if(mis.act=='down'){		
	}else if(mis.act=='win'){		
		if(mis.count<20){
			mis.count++			
		}else{
			if(mis.count==20){
				vide.style.display='block';
				vide.play();
				mis.count++
			}
		}		
	}
}
function misadraw(){
	if(mis.act=='stop'){
		mi.stop(mis.xt,mis.yt);
	}else if(mis.act=='walk'){
		miw.action(mis.xt,mis.yt);
	}else if(mis.act=='attack'){
		mia.action(mis.xt,mis.yt);
	}else if(mis.act=='dodge'){
		mido.action(mis.xt,mis.yt);
	}else if(mis.act=='damage'){
		mida.action(mis.xt,mis.yt);	
	}else if(mis.act=='down'){
		mid.action(mis.xt,mis.yt,4);
	}else if(mis.act=='win'){
		miwi.action(mis.xt,mis.yt);
	}
}
function drawf(){	
	totalv=window.innerHeight;
	totalh=window.innerWidth;
	canvas.style.top=(totalv-resize(700))/2;
	canvas.style.left=(totalh-resize(1200))/2;
	canvas.height=resize(700);
	canvas.width=resize(1200);
	incanvas.scale(resize(1),resize(1));
	vide.style.left=(totalh-resize(1190))/2;
	vide.style.top=(totalv-resize(680))/2;
	vide.height=resize(680);
	vide.width=resize(680);


	if(stage=='fight'){		
		bgmf();
		if(Math.abs((yop.xt+fx.x)-mis.xt)<400&mis.meet==false&mis.dia==false){
			mis.meet=true;
			mis.dia=true;
			mis.act='stop';
		}						
		yop1();		
		misaf();		
		bgfight.bg(fx.x,0);
		if(!mis.meet&day==1){			
			incanvas.save();
			incanvas.fillStyle='#ff6666';
			incanvas.globalAlpha=0.2;
			incanvas.fillRect(mis.xt,275,1200,430);			
			incanvas.restore();		
			diF('sub',di[lang+'attaex'],mis.xt+70,350,35);
			incanvas.save();
			incanvas.fillStyle='#66ccff';
			incanvas.globalAlpha=0.2;
			incanvas.fillRect(0,0,1200,265);			
			incanvas.fillRect(0,265,mis.xt-10,500);
			incanvas.restore();		
			diF('sub',di[lang+'dodgeex'],mis.xt+70,150,35);
		}		
		if(girl.act=='free'){
			if(girl.xt>0){
				girl.xt-=50;
				girl1.action(girl.xt+fx.x,girl.yt);
			}else{
				girl.act='gone'
				girl.xt=girl.x;
			}
		}
		if(mis.act=='dodge'||mis.act=='damage'){
			misadraw();		
			yopdraw();
		}else{			
			yopdraw();
			misadraw();		
		}				
		if(mis.meet){			
			if(mis.hp>40){
				incanvas.fillStyle='#00ff00';
			}else if(mis.hp>20){
				incanvas.fillStyle='#ffaa00';
			}else{
				incanvas.fillStyle='#ff0000';
			}
			incanvas.save();
			incanvas.globalAlpha=0.2;
			incanvas.fillRect(290,40,320,40);			
			incanvas.restore();		
			incanvas.fillRect(300,50,mis.hp*3,20);			
			
			if(yop.hp>40){
				incanvas.fillStyle='#00ff00';
			}else if(yop.hp>20){
				incanvas.fillStyle='#ffaa00';
			}else{
				incanvas.fillStyle='#ff0000';
			}
			incanvas.save();
			incanvas.globalAlpha=0.2;
			incanvas.fillRect(690,40,320,40);			
			incanvas.restore();		
			incanvas.fillRect(700,50,yop.hp*3,20);			
		}
		
		if(mis.dia){			
			diF('line',lang+day+'bf',40,550,30,1100,100);
		}
		if(girl.act=='free'){
			diF('sub',di[lang+day+'af1'],20,670,35);
		}
		if(mis.act=='win'){						
			if(mis.count>20&freeze.st==false){
				diF('line',lang+day+'wi',735,35,30,400,300);
			}
		}
	}else if(stage=='talk'){
		bgmf('bar');
		bgbar.bg(0,0);
		bgbarmisa.stop(680,600);
		if(freeze.st==false){			
			diF('line',lang+day+'tk',40,550,30,1100,100);
		}				
	}else if(stage=='sleep'){				
		bgmf('home');
		sleepv++;
		if(sleepv>30){
			sleepv=0;
		}		
		bgsleep.bg(0,0);
		if(sleepv<8){
			if(sleepv<3|sleepv>5){
				bgsleepono.bg(900,10,0);
			}
		}else{
			if(sleepv>10&sleepv<17){
				bgsleepono.bg(900,10,1);
			}else if(sleepv>20&sleepv<28){
				bgsleepono.bg(900,10,2);
			}
		}
		
		if(freeze.st==false){			
			diF('line',lang+day+'sl',40,550,30,1100,100);		
		}				
	}else if(stage=='story'){				
		if(storyv=='talk'){
			bgmf('bar');
			bgbar.bg(0,0);
			bgbarmisa.stop(680,600);
			if(freeze.st==false){			
				diF('line',lang+day+'tk',40,550,30,1100,100);
			}			
		}else if(storyv=='fight'){		
			bgmf();								
			bgfight.bg(fx.x,0);			
			yopdraw();
			misadraw();		
			if(girl.act=='free'){
				if(girl.xt>0){
					girl.xt-=50;
					girl1.action(girl.xt+fx.x,girl.yt);
				}else{
					girl.act='gone'					
					girl.xt=girl.x;
					mis.act='win';
					yop.act='down';
					vide.style.display='block';
					vide.play();
				}
			}
			if(mis.dia){				
				diF('line',lang+day+'bf',40,550,30,1100,100);
			}
			if(girl.act=='free'){
				diF('sub',di[lang+day+'af1'],20,670,35);
			}
			if(mis.act=='win'){										
				diF('line',lang+day+'wi',735,35,30,400,300);				
			}		
		}else if(storyv=='sleep'){
			bgmf('home');
			sleepv++;
			if(sleepv>30){
				sleepv=0;
			}		
			bgsleep.bg(0,0);
			if(sleepv<8){
				if(sleepv<3|sleepv>5){
					bgsleepono.bg(900,10,0);
				}
			}else{
				if(sleepv>10&sleepv<17){
					bgsleepono.bg(900,10,1);
				}else if(sleepv>20&sleepv<28){
					bgsleepono.bg(900,10,2);
				}
			}
			
			if(freeze.st==false){			
				diF('line',lang+day+'sl',40,550,30,1100,100);		
			}				
		}
		
		if(bmenub.c(m.x,m.y)){
			bgbmenu.bg(1090,390,1);			
			incanvas.fillStyle='#000000';
			incanvas.font='35px arial';	
			incanvas.fillText(di[lang+'back'],750,450);			
		}else{			
			bgbmenu.bg(1090,390,0);
		}
		
	}else if(stage=='watch'){		
		incanvas.fillStyle='#FFFFFF';
		incanvas.font='40px arial';							
		bgfight.bg(0,0);		
		incanvas.fillText((vidN+1)+'/'+vidA.length,950,50);						
		if(bnext.c(m.x,m.y)){
			watchbu.bg(900,100,1); 			
			incanvas.fillText(di[lang+'next'],800,400);						
		}else{
			watchbu.bg(900,100,0); 
		}
		if(bback.c(m.x,m.y)){
			watchbu.bg(900,500,3); 
			incanvas.fillText(di[lang+'back'],800,400);
		}else{
			watchbu.bg(900,500,2); 
		}		
		incanvas.save();
		incanvas.globalAlpha=0.5;
		incanvas.fillRect(695,65,500,30);
		incanvas.restore();
		incanvas.fillRect(700,70,(485*vide.currentTime)/vide.duration,20);
		
	}else if(stage=='menu'){		
		bgmenu.bg(0,0);		
		if(freeze.go<10){
			freeze.go++		
		}
		incanvas.save();
		incanvas.globalAlpha=freeze.go/10;		
		if(lang=='jp'){
			bgmenu.bg(0,0,1);					
		}else{
			bgmenu.bg(0,0,2);					
		}
		if(bfight.c(m.x,m.y)){
			bgmenubut.bg(910,480,1);
		}else if(bstory.c(m.x,m.y)){
			bgmenubut.bg(910,480,2);
		}else if(bwatch.c(m.x,m.y)){
			bgmenubut.bg(910,480,3);
		}else{			
			bgmenubut.bg(910,480,0);
		}
		incanvas.restore();		
		
		incanvas.fillStyle='#000000';
		incanvas.font='25px arial';
		if(bfight.c(m.x,m.y)){
			incanvas.fillText(di[lang+'fight'],25,685);
		}else if(bstory.c(m.x,m.y)){
			incanvas.fillText(di[lang+'story'],25,685);
		}else if(bwatch.c(m.x,m.y)){			
			incanvas.fillText(di[lang+'watch'],25,685);
		}
	}else if(stage==''){				
		incanvas.fillStyle='#ff0000';		
		if(ljp.c(m.x,m.y)){
			bglang.bg(0,0,1);
		}else if(len.c(m.x,m.y)){
			bglang.bg(0,0,2);
		}else {
			bglang.bg(0,0);
		}								
		incanvas.fillStyle='#000000';
		incanvas.font='25px arial';
		if(ljp.c(m.x,m.y)){
			incanvas.fillText('日本語',5,685);
		}else if(len.c(m.x,m.y)){			
			incanvas.fillText('English',5,685);
		}		
	}else if(stage=='over'){
		bgover.bg(0,0);			
		diF('sub',di[lang+'credits1'],40,600,20,1100,100,'#000000');			
		diF('sub',di[lang+'credits2'],40,630,30,1100,100,'#000000');			
		diF('sub',di[lang+'credits3'],40,660,30,1100,100,'#000000');			
		diF('sub',di[lang+'credits4'],750,500,30,700,100,'#000000');
		if(!mis.win&!freeze.st){
			diF('sub',di[lang+'cont'],600-incanvas.measureText(di[lang+'cont']).width,60,50,1100,100,'#dddddd');			
			diF('sub',10-Math.floor(freeze.go/8),600-incanvas.measureText(10-Math.floor(freeze.go/8)).width,100,30,1100,100,'#cccccc');			
			diF('sub',di[lang+'contx'],500,130,20,1100,100,'#cccccc');
		}
		freeze.go++;
		if(freeze.go>=80){
			freeze.go=0;
			freeze.st=true;			
			freeze.stage='menu';			
		}				
	}
	if(freeze.st){
		if(freeze.count<15){
			if(freeze.opa<1){
				freeze.opa+=0.1;
			}else{				
				freeze.opa=1;
				if(stage!=freeze.stage){
					if(stage=='sleep'){
						if(day<3){
							day++;
						}						
					}
					if(stage=='over'){
						vide.pause();
						vide.style.display='none';						
						vide.src='hiddenroom/win1.mp4';
					}									
					stage=freeze.stage;
					if(stage=='over'){
						vide.src='hiddenroom/gameover.mp4';
						vide.style.display='block';
						vide.play();
					}									
					if(stage=='menu'){
						day=1;
						storyv='talk';
						vide.pause();
						vide.style.display='none';
					}									
					if(stage=='fight'){
						fx.x=0;
						fx.y=0;
						mis.xt=mis.x;
						mis.yt=mis.y;
						mis.act='stop';
						mis.count=0;
						mis.meet=false;						
						mis.win=false;
						mis.hp=100;
						yop.g=this['yopa'+day+'g'];
						yop.base=this['yopa'+day+''];
						yop.w=this['yopa'+day+'w'];
						yop.a=this['yopa'+day+'a'];
						yop.da=this['yopa'+day+'da'];
						yop.d=this['yopa'+day+'d'];
						yop.wi=this['yopa'+day+'wi'];
						yop.pa=this['yopa'+day+'pa'];									
						yop.sta=3;
						yop.xt=yop.x;
						yop.yt=yop.y ;
						yop.act='hug';
						yop.g.fra=0;
						yop.count=0;
						yop.hp=100;						
						girl.act='hug';
						vide.src='hiddenroom/win1.mp4';
					}					
				}
			}
			if(freeze.opa>1){
				freeze.opa=1;
			}
		}else{
			if(freeze.opa>0){
				freeze.opa-=0.1;
			}else{
				freeze.st=false;
				freeze.opa=0;
				freeze.count=0;	
				if(stage=='watch'){
					vide.style.display='block';
					vide.play();
				}
			}
			if(freeze.opa<0){
				freeze.opa=0;
			}
		}
		incanvas.fillStyle='#000000';
		incanvas.save();	
		incanvas.globalAlpha=freeze.opa;
		incanvas.fillRect(0,0,1300,800);
		incanvas.restore();
		freeze.count++;		
	}	
};
onmousemove=function(e){	
	m.x=Math.floor(((e.clientX-((totalh/2)-(resize(1200)/2)))*1200)/resize(1200));
	m.y=Math.floor(((e.clientY-((totalv/2)-(resize(700)/2)))*700)/resize(700));		
};
onmousedown=function(e){	
	m.x=Math.floor(((e.clientX-((totalh/2)-(resize(1200)/2)))*1200)/resize(1200));
	m.y=Math.floor(((e.clientY-((totalv/2)-(resize(700)/2)))*700)/resize(700));		
	if(freeze.st==false){
		pl(seclick);
		if(stage=='fight'){
			if(mis.dia==false){
				if(mis.act=='stop'|mis.act=='walk'){									
					if(m.x>mis.xt&m.y>275){
						mis.act='attack';					
						mia.fra=0;
					}else{
						mis.act='dodge';
						mido.fra=0;
					}
				}else if(mis.act=='win'){
					if(di[lang+day+'wi'+di[1]]!=undefined&mis.count>20){
						di[1]++;
						if(	di[lang+day+'wi'+di[1]]==undefined){						
							vide.pause();
							vide.style.display='none';						
							freeze.st=true;
							freeze.stage='sleep';
							di[1]=1;
						}
					}
				}
			}else if(mis.dia){
				if(di[lang+day+'bf'+di[1]]!=undefined){
					di[1]++;
					if(	di[lang+day+'bf'+di[1]]==undefined){												
						di[1]=1;
						mis.dia=false;
					}
				}
			}			
		}else if(stage=='story'){
			if(bmenub.c(m.x,m.y)){
				freeze.st=true;
				vide.pause();
				vide.style.display='none';
				mis.dia=false;													
				vide.src='hiddenroom/win1.mp4';
				freeze.stage='menu';
				mis.win=false;
			}else{
				if(storyv=='talk'){
					if(di[lang+day+'tk'+di[1]]!=undefined){
						di[1]++;
						if(	di[lang+day+'tk'+di[1]]==undefined){							
							storyv='fight';
							yop.xt=yop.x;
							fx.x=-700;
							mis.dia=true;
							mis.xt=800;
							mis.act='stop';
							yop.act='hug';
							di[1]=1;
							yop.g=this['yopa'+day+'g'];
							yop.base=this['yopa'+day+''];
							yop.w=this['yopa'+day+'w'];
							yop.a=this['yopa'+day+'a'];
							yop.da=this['yopa'+day+'da'];
							yop.d=this['yopa'+day+'d'];
							yop.wi=this['yopa'+day+'wi'];
							yop.pa=this['yopa'+day+'pa'];							
							vide.src='hiddenroom/win'+day+'.mp4';
						}
					}
				}else if(storyv=='fight'){
					if(mis.dia==false){					
						if(mis.act=='win'){
							if(di[lang+day+'wi'+di[1]]!=undefined){
								di[1]++;
								if(	di[lang+day+'wi'+di[1]]==undefined){						
									vide.pause();
									vide.style.display='none';															
									storyv='sleep';
									mis.act='stop';
									yop.act='hug';								
									di[1]=1;
								}
							}
						}
					}else if(mis.dia){
						if(di[lang+day+'bf'+di[1]]!=undefined){
							di[1]++;
							if(	di[lang+day+'bf'+di[1]]==undefined){												
								di[1]=1;
								mis.dia=false;
								mis.meet=false;
								girl.act='hug';
								yop.act='stop';
								girl.act='free';							
							}
						}
					}			
				}else if(storyv=='sleep'){
					if(di[lang+day+'sl'+di[1]]!=undefined){
						di[1]++;
						if(	di[lang+day+'sl'+di[1]]==undefined){												
							if(day>=1){
								freeze.st=true;
								freeze.stage='over';								
							}else{			
								day++;
								storyv='talk';
							}
							di[1]=1;
						}
					}			
				}
			}
		}else if(stage=='watch'){				
			if(bnext.c(m.x,m.y)){
				vidN++;
				if(vidN+1>vidA.length){
					vidN=0;
				}
				vide.src=vidA[vidN];
				vide.play();
			}else if(bback.c(m.x,m.y)){					
				vide.pause();
				vide.style.display='none';
				vide.src=vidA[0];
				freeze.st=true;
				freeze.stage='menu';			
			}							
		}else if(stage==''){
			if(ljp.c(m.x,m.y)){
				stage='menu';
				lang='jp';
				document.title='ロックな日々（体験版）';			
			}else if(len.c(m.x,m.y)){
				stage='menu';
				lang='en';
				document.title="Rock N' Roll Days(Trial Version)";				
			}
		}else if(stage=='menu'){
			if(bfight.c(m.x,m.y)){			
				freeze.st=true;
				freeze.stage='talk';				
			}else if(bstory.c(m.x,m.y)){			
				freeze.st=true;
				freeze.stage='story';				
				mis.win=true;
			}else if(bwatch.c(m.x,m.y)){			
				freeze.st=true;
				freeze.stage='watch';								
			}
		}else if(stage=='talk'){		
			if(di[lang+day+'tk'+di[1]]!=undefined){
				di[1]++;
				if(	di[lang+day+'tk'+di[1]]==undefined){
					freeze.st=true;
					freeze.stage='fight';
					di[1]=1;
				}
			}
		}else if(stage=='sleep'){		
			if(di[lang+day+'sl'+di[1]]!=undefined){
				di[1]++;
				if(	di[lang+day+'sl'+di[1]]==undefined){
					freeze.st=true;
					if(day>=1){
						freeze.stage='over';
					}else{			
						freeze.stage='talk';
					}
					di[1]=1;
				}
			}			
		}else if(stage=='over'){		
			if(!mis.win){
				freeze.go=0;						
				freeze.st=true;
				freeze.stage='fight'
				pl(semia);
			}
		}
	}
};
window.onload=function(){
	drawIn=setInterval(drawf,100);
};
